package com.weaver.seconddev.controller;

import cn.hutool.json.JSONObject;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.seconddev.util.DataOperateUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

/**
 * @Author: calyrex
 * @CreateTime: 2025-05-19
 * @Description:
 */


@Slf4j
@RestController
@RequestMapping({"/papi/secondev/workflow" })
public class Showhl_controller {

    @Autowired
    private DataOperateUtil dataOperateUtil;


    @RequestMapping("/Showhl")
    public WeaResult<JSONObject> execute(@RequestParam Map<String,Object> params) {
        log.info("Showhl_controller execute start");
        log.info("Showhl_controller execute params : " + params);
        String zt = dataOperateUtil.null2String(params.get("zt"));
        JSONObject jsonObject = new JSONObject();
        Float tz = 0.0f;
        Float my = 0.0f;
        Float result = 0.0f;
        String sql = "";
        try {
            sql = "select azk03 from HOXIN.azk_file where azk01='USD' and year(azk02) = year(sysdate) and month(azk02) = month(sysdate) and day(azk02) = day(sysdate)";
            String SourceType = "EXTERNAL";
            String groupId = "Topgp";
            Map<String, Object> datas = dataOperateUtil.executeForQuery(SourceType, groupId, sql);
            if (datas != null && datas.size() > 0) {
                if (String.valueOf(datas.get("status")).equals("OK")) {
                    List<Map<String, Object>> records = (List<Map<String, Object>>) datas.get("records");
                    if (records.size() > 0) {
                        Map<String, Object> map = records.get(0);
                        tz = Float.valueOf(map.get("azk03").toString());
                    }
                }
            }
            sql = "select azj03 from hxjm.azj_file where azj01 = 'USD' and ((year(to_date(azj02, 'yyyy-mm')) = year(sysdate)) and (month(to_date(azj02, 'yyyy-mm')) = month(sysdate)))";
            datas = dataOperateUtil.executeForQuery(SourceType, groupId, sql);
            if (datas != null && datas.size() > 0) {
                if (String.valueOf(datas.get("status")).equals("OK")) {
                    List<Map<String, Object>> records = (List<Map<String, Object>>) datas.get("records");
                    if (records.size() > 0) {
                        Map<String, Object> map = records.get(0);
                        my = Float.valueOf(map.get("azj03").toString());
                    }
                }
            }

            result = tz / my;
            jsonObject.put("result",result);
            return WeaResult.success(jsonObject);
        }catch (Exception e){
            log.error("Showhl_controller execute error : " , e);
            return WeaResult.fail(500, "Showhl_controller execute error", e);
        }
    }
}
